CON              
                                                           
  _CLKMODE = XTAL1 + PLL16X                              
  _XINFREQ = 5_000_000

  PST_BAUD = 9_600
  MAX_COLOR = 255
  DEFAULT_BRIGHTNESS = MAX_COLOR / 3  ' Use 255 for maximum brightness.
  NEOPIXEL_PIN = 15
  COLORPAL_PIN = 0
        
  LEDS_IN_RING = 10 '16
  RINGS_IN_USE = 1 '3
  TOTAL_LEDS = LEDS_IN_RING * RINGS_IN_USE

  MAX_LED_INDEX = TOTAL_LEDS - 1
       
VAR

  long red, green, blue
  
OBJ

  Strip : "jm_ws2812"
  ColorPal  : "ColorPAL"                 
  Pst : "Parallax Serial Terminal"
                   
PUB Setup 
    
  Strip.Start(NEOPIXEL_PIN, TOTAL_LEDS)
  ColorPal.Start(COLORPAL_PIN)
  Pst.Start(PST_BAUD)

  Pst.Str(string(11, 13, "NeoPal"))  
  Pst.Str(string(11, 13, "NeoPixels Controlled by a ColorPAL"))

  MainLoop
  
PUB MainLoop | maxColor, fullBrightnessRed, fullBrightnessGreen, fullBrightnessBlue

  repeat
    longmove(@red, ColorPal.GetRGB, 3)    'Get color values.
    if red => green and red => blue
      maxColor := red
    elseif green => red and green => blue
      maxColor := green
    else
      maxColor := blue
       
    Pst.Str(string(11, 13, "R = $"))          
    Pst.Hex(red, 4)
    Pst.Str(string(", G = $"))
    Pst.Hex(green, 4)
    Pst.Str(string(", B = $"))
    Pst.Hex(blue, 4)
    Pst.Str(string(", maxColor = $"))
    Pst.Hex(maxColor, 4)
    fullBrightnessRed := red * MAX_COLOR / maxColor
    fullBrightnessGreen := green * MAX_COLOR / maxColor
    fullBrightnessBlue := blue * MAX_COLOR / maxColor
    Pst.Str(string(", full R = $"))          
    Pst.Hex(fullBrightnessRed, 4)
    Pst.Str(string(", G = $"))
    Pst.Hex(fullBrightnessGreen, 4)
    Pst.Str(string(", B = $"))
    Pst.Hex(fullBrightnessBlue, 4)
    {Strip.Fill(0, last, Strip.Colorx(fullBrightnessRed, fullBrightnessGreen, {
    } fullBrightnessBlue, DEFAULT_BRIGHTNESS))  } 'use "Fill" method to partial fill strip
    Strip.Set_all(Strip.Colorx(fullBrightnessRed, fullBrightnessGreen, fullBrightnessBlue, {
    } DEFAULT_BRIGHTNESS))
